Package org.optaplanner.core.impl.score.stream.bavet.tri

## Class BavetScoringTriNode<A,​B,​C>

- java.lang.Object
- - org.optaplanner.core.impl.score.stream.bavet.common.BavetAbstractNode
  - - org.optaplanner.core.impl.score.stream.bavet.tri.BavetAbstractTriNode<A,​B,​C>
    - - org.optaplanner.core.impl.score.stream.bavet.tri.BavetScoringTriNode<A,​B,​C>

- All Implemented Interfaces:
    `BavetNode`, `BavetScoringNode`

      public final class BavetScoringTriNode<A,​B,​C>
      extends BavetAbstractTriNode<A,​B,​C>
      implements BavetScoringNode

- - ### Field Summary

    - ### Fields inherited from class org.optaplanner.core.impl.score.stream.bavet.common.BavetAbstractNode

      `nodeIndex, session`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `BavetScoringTriNode​(BavetConstraintSession session, int nodeIndex, String constraintPackage, String constraintName, Score<?> constraintWeight, QuadFunction<A,​B,​C,​Consumer<Score<?>>,​UndoScoreImpacter> scoreImpacter)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `<Score_ extends Score<Score_>> ConstraintMatchTotal<Score_>` | `buildConstraintMatchTotal​(Score_ zeroScore)` |
    `BavetScoringTriTuple<A,​B,​C>` | `createTuple​(BavetAbstractTriTuple<A,​B,​C> parentTuple)` |
    `String` | `getConstraintId()` |
    `String` | `getConstraintName()` |
    `String` | `getConstraintPackage()` |
    `Score<?>` | `getConstraintWeight()` |
    `void` | `refresh​(BavetAbstractTuple uncastTuple)` |
    `String` | `toString()` |

    - ### Methods inherited from class org.optaplanner.core.impl.score.stream.bavet.tri.BavetAbstractTriNode

      `addChildNode, getChildNodeList`

    - ### Methods inherited from class org.optaplanner.core.impl.score.stream.bavet.common.BavetAbstractNode

      `getNodeIndex`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.optaplanner.core.impl.score.stream.bavet.common.BavetNode

      `getNodeIndex`

- - ### Constructor Detail

    - #### BavetScoringTriNode

          public BavetScoringTriNode​(BavetConstraintSession session,
                                     int nodeIndex,
                                     String constraintPackage,
                                     String constraintName,
                                     Score<?> constraintWeight,
                                     QuadFunction<A,​B,​C,​Consumer<Score<?>>,​UndoScoreImpacter> scoreImpacter)

  - ### Method Detail

    - #### createTuple

          public BavetScoringTriTuple<A,​B,​C> createTuple​(BavetAbstractTriTuple<A,​B,​C> parentTuple)

      Specified by:
        `createTuple` in class `BavetAbstractTriNode<A,​B,​C>`

    - #### refresh

          public void refresh​(BavetAbstractTuple uncastTuple)

      Specified by:
        `refresh` in class `BavetAbstractNode`

    - #### buildConstraintMatchTotal

          public <Score_ extends Score<Score_>> ConstraintMatchTotal<Score_> buildConstraintMatchTotal​(Score_ zeroScore)

      Specified by:
        `buildConstraintMatchTotal` in interface `BavetScoringNode`
      Type Parameters:
        `Score_` - the `Score` type
      Parameters:
        `zeroScore` - never null
      Returns:
        never null

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### getConstraintPackage

          public String getConstraintPackage()

      Specified by:
        `getConstraintPackage` in interface `BavetScoringNode`
      Returns:
        never null

    - #### getConstraintName

          public String getConstraintName()

      Specified by:
        `getConstraintName` in interface `BavetScoringNode`
      Returns:
        never null

    - #### getConstraintId

          public String getConstraintId()

      Specified by:
        `getConstraintId` in interface `BavetScoringNode`
      Returns:
        never null

    - #### getConstraintWeight

          public Score<?> getConstraintWeight()

      Specified by:
        `getConstraintWeight` in interface `BavetScoringNode`
      Returns:
        never null